
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int dx[] = {0,0,1,-1};
int dy[] = {1,-1,0,0};

int field[302][302];
bool found[302][302];

int main(void){
	while(true){
		int h,w;
		cin >> h >> w;
		if(!(h|w)) break;
		for(int y=0;y<h+2;y++)
			for(int x=0;x<w+2;x++){
				field[y][x] = -1;
				found[y][x] = false;
			}
		pair<int,int> start, goal;
		for(int y=1;y<=h;y++){
			string s;
			cin >> s;
			for(int x=1;x<=w;x++){
				char c = s[x-1];
				if(c=='Y'){
					start = make_pair(y,x);
					field[y][x] = 1;
				}else if(c =='T'){
					goal = make_pair(y,x);
					field[y][x] = 1;
				}else if(c == 'B'){
					field[y][x] = 2;
				}else if(c == 'E'){
					field[y][x] = 1;
				}
			}
		}
		vector<pair<int,int> > trgs[3];
		trgs[1].push_back(start);
		bool ok = false;
		int ans = -1;
		while(true){
			ans++;
			trgs[0].swap(trgs[1]);
			trgs[1].swap(trgs[2]);
			trgs[2].clear();
			if(trgs[0].empty() && trgs[1].empty()) break;
			for(int i=0;i<trgs[0].size();i++){
				int y = trgs[0][i].first;
				int x = trgs[0][i].second;
				if(found[y][x]) continue;
				found[y][x] = true;
				if(trgs[0][i] == goal){
					ok = true;
					break;
				}
				for(int t=0;t<4;t++){
					int ny = y + dy[t];
					int nx = x + dx[t];
					if(field[ny][nx] == -1) continue;
					trgs[field[ny][nx]].push_back(make_pair(ny,nx));
				}
			}
			if(ok) break;
		}
		if(ok){
			cout << ans << endl;
		}else{
			cout << -1 << endl;
		}
	}
	return 0;
}
